# 1 "../../library/init/In_main.c"

 
 
 
 
 
 
 
 
 
 
 
 
 
 
 

 
 

 

# 1 "../../library/init/../../Include/std_c.h" 1
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 




 
 
 
typedef unsigned int        u_int   ;
typedef unsigned short      u_short ;
typedef unsigned char       u_char ;

 
 
 


 
 
 




# 23 "../../library/init/In_main.c" 2

# 1 "../../library/init/../../Include/ebi.h" 1
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 




 
 
 

typedef struct
{
    volatile u_int         EBI_CSR[8] ;         
    volatile u_int         EBI_RCR ;            
    volatile u_int         EBI_MCR ;            
} StructEBI ;

 
 
 

 




 











 




 






 











 




 






 
 
 

 







 




 
 
 



 
 
 


 




# 24 "../../library/init/In_main.c" 2


 
 

 


extern void InitResetStacks( void );
extern int  MainApplication( void );


 
 

 






 
 
 
 
 
 
 
int main ( void )

 
{
 
      InitResetStacks();
 
      return MainApplication();
 
}




 
 
 
 
 
 
 
 
 int InitMainSram(void)  

 
{
    unsigned int offset;
    int saved_byte;
    int i,done;
    int sram_offset;

     
    int sram_base = (((StructEBI *) 0xFFE00000) ->EBI_CSR[1] & 0xFFFF0000);

    offset = 0;
    done = 0 ;
    while((offset < 0x7f0000) && (done == 0 ))
    {
    	offset += 0x00010000;
    	done = 1 ;
	sram_offset = sram_base + offset;
    	for(i=0;(i<8) && (done == 1 );i++)
    		if (*(volatile int *)(sram_base + i) != *(volatile int *)(sram_offset + i))
    			done = 0 ;
	saved_byte = *(volatile int *)(sram_base + offset);
	*(volatile int *)(sram_base + offset) = 0x55aa55aa;
	if (*(volatile int *)(sram_base + offset) != 0x55aa55aa)
		done = 1 ;
	*(volatile int *)(sram_base + offset) = saved_byte;
    }

     
    return (sram_base + offset);

 
} 



