/*
-----------------------------------------------------------------------------
-      ATMEL Microcontroller Software Support  -   ROUSSET -
-----------------------------------------------------------------------------
 The software is delivered "AS IS" without warranty or condition of any
 kind, either express, implied or statutory. This includes without
 limitation any warranty or condition with respect to merchantability or
 fitness for any particular purpose, or against the infringements of
 intellectual property rights of others.
-----------------------------------------------------------------------------
- File Name            : eb01.inc
- Object               : Evaluation Board EB01 Definition File.
- Translator           : ARM Software Development Toolkit V2.11a
-
- 1.0 22/09/98 JCZ     : Creation
- 2.0 21/10/98 JCZ     : Clean up.
-----------------------------------------------------------------------------
*/
/*
---------------------------------------
- AT91EB01 External Memories Definition
---------------------------------------
*/
/*- Flash Memory : AT29LV1024 64k*16 */
.equ	FLASH_BASE,0x01000000

/*- SRAM : size is depending on the devices fitted on the board */
.equ	SRAM_BASE,0x02000000

/*
--------------------------------
- AT91EB01 Interfaces Definition
--------------------------------
*/
/*- Red Led */
.equ	LED1,P1
/*- Amber Led */
.equ	LED2,P4
/*- Green Led */
.equ	LED3,P2

/*- SW3 Push Button */
.equ	IRQ_SW3,FIQ
.equ	PIN_SW3,P12

/*- SW4 Push Button */
.equ	PIN_SW4,P5

/*- SW5 Push Button */
.equ	IRQ_SW5,IRQ0
.equ	PIN_SW5,P9


